#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR DATA FILES  

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use psfp;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

$createdir_wait = 0;
$movelinks_wait = 1;
$removedir_wait = 0;
$updatelinknr_wait = 0;


##################################################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") { &start; }


##################################################################################





sub start
{

$ct = $q->param('ct'); ### ORIGINAL CAT
$cid = $q->param('cid'); ### ORIGINAL CID
$rid = $q->param('rid'); ### ORIGINAL RID

$mct = $q->param('mct'); ### TO MOVE TO CAT
$mlv = $q->param('mlv'); ### TO MOVE LEVEL
$mcid = $q->param('mcid'); ### TO MOVE CID

$last_dname = acs::get_last_dirname($mct);


### REMOVE TEMP FILES




########

$location = acs::get_location_string ($ct);

########

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
 
########

if ($mlv == 0)
	{
	$sth = $dbh->prepare("SELECT * FROM dirs WHERE (level = '1') AND ((crosslinkid IS NULL) OR (crosslinkid < 1)) ORDER BY shortname ASC");
	}
	else
	{
	$mlv++;
	@adir = split (/-/, $mct);
	
	$querystr = "";

	for ($ms = 0; $ms < 16; $ms++) 
		{
		if ($adir[$ms] ne "") {$adir[$ms] = acs::decode_dir($adir[$ms]);}

		$acnt = $ms + 1;
		if ($acnt != $mlv)
			{
			if ($adir[$ms] ne "")
				{
				$adir[$ms] =~ s/'/\\'/g;
				}
			$querystr = $querystr . " (l" . "$acnt = '$adir[$ms]') and";
			}
		$acnt++;
		}
	$querystr = substr($querystr, 0, length($querystr) - 3);
	$sth = $dbh->prepare("SELECT * FROM dirs WHERE (level = '$mlv') AND $querystr AND ((crosslinkid IS NULL) OR (crosslinkid < 1)) ORDER BY shortname ASC");
	
	}

##############

if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }

$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
$rows = $sth->rows();

$smc = 0;
while ( @row = $sth->fetchrow() )
	{
	$mlv = $row[1];

	$row[2] = acs::encode_dir($row[2]); $dirstring = $row[2];														#1
	if ($row[3] ne "") { $row[3] = acs::encode_dir($row[3]); $dirstring =   $dirstring . "-$row[3]"; } #2
	if ($row[4] ne "") { $row[4] = acs::encode_dir($row[4]); $dirstring =   $dirstring . "-$row[4]"; } #3
	if ($row[5] ne "") { $row[5] = acs::encode_dir($row[5]); $dirstring =   $dirstring . "-$row[5]"; } #4
	if ($row[6] ne "") { $row[6] = acs::encode_dir($row[6]); $dirstring =   $dirstring . "-$row[6]"; } #5
	if ($row[7] ne "") { $row[7] = acs::encode_dir($row[7]); $dirstring =   $dirstring . "-$row[7]"; } #6
	if ($row[8] ne "") { $row[8] = acs::encode_dir($row[8]); $dirstring =   $dirstring . "-$row[8]"; } #7
	if ($row[9] ne "") { $row[9] = acs::encode_dir($row[9]); $dirstring =   $dirstring . "-$row[9]"; } #8
	if ($row[10] ne ""){ $row[10] = acs::encode_dir($row[10]); $dirstring = $dirstring ."-$row[10]"; } #9
	
	if ($row[11] ne ""){ $row[10] = acs::encode_dir($row[11]); $dirstring = $dirstring ."-$row[11]"; } #10
	if ($row[12] ne ""){ $row[10] = acs::encode_dir($row[12]); $dirstring = $dirstring ."-$row[12]"; } #11
	if ($row[13] ne ""){ $row[10] = acs::encode_dir($row[13]); $dirstring = $dirstring ."-$row[13]"; } #12
	if ($row[14] ne ""){ $row[10] = acs::encode_dir($row[14]); $dirstring = $dirstring ."-$row[14]"; } #13
	if ($row[15] ne ""){ $row[10] = acs::encode_dir($row[15]); $dirstring = $dirstring ."-$row[15]"; } #14
	if ($row[16] ne ""){ $row[10] = acs::encode_dir($row[16]); $dirstring = $dirstring ."-$row[16]"; } #15
	if ($row[17] ne ""){ $row[10] = acs::encode_dir($row[17]); $dirstring = $dirstring ."-$row[17]"; } #16

	if ($row[20] eq "") { $row[20] = 0; }

	$locked_stat = "";
	if ($row[22] eq "Y") { $locked_stat = " <img src=\"$web_url/locked.gif\">"; }

	if ($last_dname eq "") { $last_dname = "Root "; $rootcrit = "<input type=\"radio\" name=\"movecat\" $selbox value=\"root\" checked>";}
	if ($smc == 0) 
		{
		$movedirs = $movedirs . "$rootcrit <img src=\"$web_url/dir.gif\"> <b>$last_dname</b> <br>";
		if ($rootcrit eq "") {$selbox = "checked";}
		}
		else
		{
		$selbox = "";
		}
	$smc++;
	
	$moveval = "$row[0]" . "___MVSPLT___" . "$row[28]";
	
	if ($row[22] ne "H")
		{
		$movedirs = $movedirs . "<input type=\"radio\" name=\"movecat\" $selbox value=\"$moveval\"> <img src=\"$web_url/subdir.gif\"> <a href=\"$admin_url/admin62.cgi?mlv=$mlv&mct=$dirstring&cid=$cid&rid=$rid&&ct=$ct&$selstring&opaction=$opaction&$newsub\">$row[28]</a></strong> ($row[20]) $locked_stat<br>";
		}
		else
		{
		$movedirs = $movedirs . "<input disabled type=\"radio\" name=\"movecat\" $selbox value=\"$moveval\"> <img src=\"$web_url/subdir.gif\"><font color=\"#808080\"> $row[28]</strong> ($row[20]) </font>$locked_stat<br>";
		}
	}

$sth->finish;
$dbh->disconnect;

#### CURRENT MOVE LOCATION

if ($mct eq "")
	{
	$currentloc = "Root ";
	}
	else
	{
	$currentloc = "<a href=\"$admin_url/admin62.cgi?mlv=&mct=&cid=$cid&rid=$rid&ct=$ct&$selstring&opaction=$opaction&$newsub\">Root</a> ";
	
	$n_mlv = 1;
	
	@allds = split (/-/, $mct);
	$ccnr = @allds;

	foreach $aitem (@allds)
		{
		$n_mct = $n_mct . $aitem . "-";
		
		$cdname = acs::decode_dir($aitem);
		
		$cnn_mct = substr($n_mct, 0, length($n_mct) - 1);
		
		if ($ccnr ne $n_mlv)
			{
			$currentloc = $currentloc . " > <a href=\"$admin_url/admin62.cgi?mlv=$n_mlv&mct=$cnn_mct&cid=$cid&rid=$rid&ct=$ct&$selstring&opaction=$opaction&$newsub\">$cdname</a> ";
			}
			else
			{
			$currentloc = $currentloc . " > $cdname ";
			}
		
		$n_mlv++;
		}
	
	}

#### 

if ($dirstring !~ /-/)
	{
	$pmct = "";
	}
	else
	{
	$pmct = "$mct";
	}


#####

if ($mlv eq "")
	{
	$create_lv = 0;
	}
	else
	{
	$create_lv = $mlv -1;
	}

if ($rows == 0)
	{
$movedirs = <<END_OF_NONE;

<p><strong>This category contains no sub
directories/categories. <br>
</strong>Use the back button of your
browser to go back.</p>

END_OF_NONE
	}
	else
	{

if ($opaction eq "Copy")
		{
		$movebut = "<input type=\"submit\" value=\"   Copy   \" name=\"movebutton\">";
		}
		else
		{
		$movebut = "<input type=\"submit\" value=\"   Move   \" name=\"movebutton\">";
		}
	}

###############

$move_title = "Move Category";
$movew = "Move";
$faction = "move_operation1";


###############	

if ($q->param('newsub') eq "true")
	{
	$location = "New Submissions";
	}


if ($config_cgi ne "../config.cgi")
{
$nlck = $config_cgi;
$nlck =~ s/config\.cgi/admin\/unlock\.cgi/gi;
}
else
{
$nlck = "unlock.cgi";
}

if ((-e $nlck) > 0)
	{
	$movecgi = "$admin_url/unlock.cgi";
	}
	else
	{
	$movecgi = "$admin_url/admin40.cgi";
	}




$movedisp = acs::get_heading_box("$web_url/add.gif", "$move_title", "Select a radio button below to select a Directory/Category. Navigate the Directories/Categories by clicking on the Directory/Category name.");


$hhelp_h = acs::quick_help("Note:", "Moving hundreds of categories at a time can be
a lengthy process. The reason for this is that the moving process is split up in sections
to avoid browser time-outs and limitations. It might also be a good idea to make a backup
of your database when moving hundreds of categories as any interuption in connectivity
(your internet connection) or the closing of the browser window can cause an incomplete
move.");

print <<END_OF_MVL;

<html>
<head>
<title>$move_title</title>
<script LANGUAGE="JavaScript">
<!-- Hide
  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
	var random = parseInt(Math.random()*10000)

	  var popupwin = null;
      myWindow = open (loc, popupwin + random, myspecs);
      myWindow.moveTo(100,40);
      myWindow.focus();
    }

 // End Hide -->
</script>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>

$movedisp

<form method="POST" action="$movecgi">
  <input type="hidden" name="fct" value="$faction">
  <input type="hidden" name="ct" value="$ct">
  <input type="hidden" name="links_to_move" value="$hselstring">
  <input type="hidden" name="cid" value="$cid">
  <input type="hidden" name="rid" value="$rid">
  <input type="hidden" name="mct" value="$pmct">
  <input type="hidden" name="newsub" value="$newsub2">
  <input type="hidden" name="email" value="$newsubemail">
  
 
 <table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#E1E1E1">
   <tr>
     <td width="99%" valign="top" bgcolor="#FFFFFF"><table width="100%" border="0" cellpadding="6">
       <tr>
         <td background="$web_url/bar6.gif"><strong class="normaltext">Tree Display</strong></td>
         </tr>
       <tr>
         <td class="normaltext"><p>$movew Category: <strong><img src="$web_url/lar.gif" width="6" height="10"> <strong>$location</strong> </strong></p>
           <p>$movew Category To: <img src="$web_url/lar.gif" width="6" height="10"> <b>$currentloc</b></p>
           <blockquote>
           	<BR>
             <p>$movedirs</p>
            <BR>
           </blockquote>
           <p>
           $movebut <input type="submit" value="   Add Dir    " name="createdir" 
  onClick="popup('$admin_url/admin2.cgi?fct=addir&amp;ct=$mct&amp;lv=$create_lv&amp;mscr=mscr',600,400);return false;">
 </p></td>
         </tr>
 
     </table></td>
   </tr>
 </table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>
</form>

$hhelp_h

</body>
</html>

END_OF_MVL

}



sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

